
-- deutzFah7250GPuma
-- Specialization for deutzFah7250GPuma mod
-- Date 17/03/2015
-- Copyright (C) fozzy691
-- Contact via PM @ romuald.brun691@orange.fr


deutzFah7250GPuma = {};

function deutzFah7250GPuma.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function deutzFah7250GPuma:load(xmlFile)
	self.frontLinkageBottomArmRotNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm1#rotationNode"));
	setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-77), math.rad(-12.948), math.rad(-17.21));
	self.frontLinkageBottomArmRotNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm2#rotationNode"));
	setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-77), math.rad(12.948), math.rad(17.21));
end;

function deutzFah7250GPuma:delete()
end;

function deutzFah7250GPuma:readStream(streamId, connection)
end;

function deutzFah7250GPuma:writeStream(streamId, connection)
end;

function deutzFah7250GPuma:mouseEvent(posX, posY, isDown, isUp, button)
end;

function deutzFah7250GPuma:keyEvent(unicode, sym, modifier, isDown)
end;

function deutzFah7250GPuma:update(dt)
end;

function deutzFah7250GPuma:updateTick(dt)
end;

function deutzFah7250GPuma:draw()
end;

function deutzFah7250GPuma:onLeave()
end;

function deutzFah7250GPuma:onEnter()
end;

function deutzFah7250GPuma:attachImplement(implement)
	local jointType = implement.object.attacherJoint.jointType;
	local jointIndex = implement.jointDescIndex;

	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if implement.object.needsLowering then
			self.implementCount = math.max(self.implementCount - 1, 0);
		end;
		if jointIndex == 2 then
			setRotation(self.frontLinkageBottomArmRotNode1, math.rad(0), math.rad(0), math.rad(0));
			setRotation(self.frontLinkageBottomArmRotNode2, math.rad(0), math.rad(0), math.rad(0));
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILER then
		if jointIndex == 3 then
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
		if jointIndex == 4 then
		end;
	end;

	self.updateJoint = true;
end;

function deutzFah7250GPuma:detachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex];
	local jointIndex = implement.jointDescIndex;

	if implement.object.attacherJoint.jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if implement.object.needsLowering then
			self.implementCount = self.implementCount + 1;
		end;
		if jointIndex == 2 then
			setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-77), math.rad(-12.948), math.rad(-17.21));
			setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-77), math.rad(12.948), math.rad(17.21));
		end;
	else
	end;
	
	self.updateJoint = true;
end;

function deutzFah7250GPuma:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
